﻿using UnityEngine;
using System.Collections;

public class playerController : MonoBehaviour {
	public float speed = 10f;
	public float spawnDist = 0;
	public float bulletSpeed = 20f;
	public GameObject bulletPrefab;
	public int reloadTime = 25;
	public int reload = 0;
	public int inv = 0;
	public int maxInv = 50;
	public int nano = 100;
	public int shotCost = 5;
	public int tank = 100;

	// Use this for initialization
	void Start () {
		spawnDist = (this.transform.lossyScale.x + bulletPrefab.transform.lossyScale.x) / 2f;
	}
	
	// Update is called once per frame
	void Update () {
		if (nano > tank) {
			nano = tank;
		}
		Vector3 speedvec = Vector3.zero;
		Vector3 bulletVel = Vector3.zero;
		Vector3 bulletPos = Vector3.zero;
		if (Input.GetKey (KeyCode.A)) {
			speedvec.x -= speed;
		}
		if (Input.GetKey (KeyCode.D)) {
			speedvec.x += speed;
		}
		if (Input.GetKey (KeyCode.W)) {
			speedvec.z += speed;
		}
		if(Input.GetKey(KeyCode.S)){
			speedvec.z -= speed;
		}
		this.rigidbody.velocity = speedvec;
		//print (speedvec.x);
		//print (speedvec.y);
		if (reload > 0)
			return;
		bulletPos = this.transform.position;
		if(Input.GetKey(KeyCode.UpArrow)){
			bulletVel.z += bulletSpeed;
			bulletPos.z += spawnDist;
		}
		if(Input.GetKey(KeyCode.DownArrow)){
			bulletVel.z -= bulletSpeed;
			bulletPos.z -= spawnDist;
		}
		if(Input.GetKey(KeyCode.LeftArrow)){
			bulletVel.x -= bulletSpeed;
			bulletPos.x -= spawnDist;
		}
		if(Input.GetKey(KeyCode.RightArrow)){
			bulletVel.x += bulletSpeed;
			bulletPos.x += spawnDist;
		}
		if (bulletVel == Vector3.zero) return;
		GameObject bulletMake = Instantiate (bulletPrefab) as GameObject;
		bulletMake.transform.position = bulletPos;
		bulletMake.rigidbody.velocity = bulletVel;
		reload = reloadTime;
		nano -= shotCost;
		if (nano == 0) {
			Application.LoadLevel("_Scene_0");
		}
	}

	void FixedUpdate(){
		if (reload > 0) reload--;
		if (inv > 0) inv--;
		if (inv % 2 == 1) {
			this.renderer.enabled = !this.renderer.enabled;
		}
		if (inv == 0) {
			this.renderer.enabled = true;
		}
	}

	public void OnHit(int dam){
		if (inv == 0) {
			if(nano > dam) nano -= dam;
			else nano = 0;
			inv = maxInv;
			if(nano == 0) Application.LoadLevel("_Scene_0");
		}
	}
}
