﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class upgradeManager : MonoBehaviour {
	public int tankCost = 50;
	public playerController player;
	public int valueCost = 60;
	public gameManager gam;
	public int reloadCost = 20;
	public int speedCost = 30;
	public List<GameObject> enemies;

	void Awake(){
		enemies = new List<GameObject>();
	}

	// Use this for initialization
	void Start () {
		player = GameObject.Find("Player").GetComponent<playerController>();
		gam = GameObject.Find ("Main Camera").GetComponent<gameManager> ();
	}
	
	// Update is called once per frame
	void Update () {
		if (Input.GetKeyDown (KeyCode.U) && player.nano > tankCost + 10) {
			player.nano -= tankCost;
			tankCost *= 2;
			player.tank *= 2;
		}
		if (Input.GetKeyDown (KeyCode.I) && player.nano > valueCost + 10) {
			player.nano -= valueCost;
			valueCost *= 2;
			gam.enemyPrefab.GetComponent<enemyManager>().value *= 2;
			foreach(GameObject ene in enemies){
				ene.GetComponent<enemyManager>().value *= 2;
			}
		}
		if (Input.GetKeyDown (KeyCode.O) && player.nano > reloadCost + 10) {
			player.nano -= reloadCost;
			reloadCost *= 2;
			player.reloadTime -= 2;
		}
		if (Input.GetKeyDown (KeyCode.P) && player.nano > speedCost + 10) {
			player.nano -= speedCost;
			speedCost *= 2;
			player.speed += 5;
		}
	}
}
